﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.UI;

public class GameLogic : MonoBehaviour {
	// Instance for singleton class
	public static GameLogic Instance = null;
	void Awake () {
		if (Instance == null) {
			Instance = this;
		} else if (Instance != this) {
			Destroy (gameObject);
		}
	}

	public int GameState = 0;
	public const int GAMESTATE_PLAYING = 0;
	public const int GAMESTATE_OVER = 1;
		
	public static int mapsize = 10;
//	public GameObject[] TileArray = new GameObject[mapsize*mapsize + 1];
	public Sprite grass;
	public Sprite building1;
	public Sprite building2;
	public Sprite building3;
	public Text clicksText;
	public GameObject people1;
	public GameObject people2;
	GameObject[] freePopArray = new GameObject[10];
	GameObject[] popArray = new GameObject[20];
	public GameObject clickMarker;

	public int freePopulation = 3;
	public int population = 0;
	int clicks = 3;
	public int maxClicks = 3;

	public bool abandon = false;

	float clickCooldownTimer;
	float clickCooldownTime = 0.1f;
	bool clickCooldown = false;

	float waveCooldownTimer;
	public float waveCooldownTime = 3f;
	public bool waveCooldown = true;

	void Start(){
		for (int x = 0; x < freePopArray.Length; x++) {
			freePopArray[x] = (GameObject)Instantiate (people1, new Vector3 (-7.5f, -3.5f + x, 0f), Quaternion.identity);
		}
		for (int x = 0; x < popArray.Length; x++) {
			if (x < 9) {
				popArray [x] = (GameObject)Instantiate (people2, new Vector3 (7f, -3.5f + x, 0f), Quaternion.identity);
			} else {
				popArray [x] = (GameObject)Instantiate (people2, new Vector3 (6f, -3.5f + x - 9, 0f), Quaternion.identity);
			}
		}
	}

	void Update () {
		foreach (GameObject freePeople in freePopArray) {
			freePeople.SetActive (false);
		}

		for (int x = 0; x < freePopulation; x++) {
			if (x < freePopArray.Length) {
				freePopArray [x].SetActive (true);
			}
		}

		foreach (GameObject people in popArray) {
			people.SetActive (false);
		}
		for (int x = 0; x < (population / 5); x++) {
			popArray [x].SetActive (true);
		}

		if (Input.GetAxis ("Exit") > 0.1f) {
			Application.Quit ();
		}

		if (GameState == GAMESTATE_PLAYING) {
			clicksText.text = "Clicks " + clicks + ", free population: " + freePopulation + ", population: " + population;
			if (population >= 70) {
				GameState = GAMESTATE_OVER;
				clicksText.text = "Population: " + population + " YOU WIN!";
			}

			Vector3 clickPosition = Camera.main.ScreenToWorldPoint (Input.mousePosition);
			RaycastHit2D tileHit = Physics2D.Raycast (clickPosition, Vector2.zero);
			if (Input.GetAxis ("Click") > 0.1f) {
				if (tileHit != null && tileHit.collider != null && clickCooldown == false && clicks > 0) {
//				SpriteRenderer spriteRend = tileHit.collider.gameObject.GetComponent<SpriteRenderer> ();
//				if (spriteRend.sprite == grass) {
//					spriteRend.sprite = building1;
//				} else if (spriteRend.sprite == building1) {
//					spriteRend.sprite = building2;
//				} else if (spriteRend.sprite == building2) {
//					spriteRend.sprite = building3;
//				}
					tileHit.collider.gameObject.GetComponent<Tile> ().IncreaseZoning ();

					clickCooldown = true;
					clicks--;
				}
			}
		

		if (clickCooldown == true) {
			if (clickCooldownTimer < clickCooldownTime) {
				clickCooldownTimer += Time.deltaTime;
			} else {
				clickCooldown = false;
				clickCooldownTimer = 0f;
			}
		}

		if (waveCooldown == true) {
			if (waveCooldownTimer < waveCooldownTime) {
				waveCooldownTimer += Time.deltaTime;
			} else {
				waveCooldown = false;
				waveCooldownTimer = 0f;
			}
		}

			if (waveCooldown == false) {
			
//			List<GameObject> upgradableTiles = new List<GameObject> ();
//			List<GameObject> emptyTiles = new List<GameObject> ();
//			foreach (GameObject tileobject in TileArray) {
//				Tile tile = tileobject.GetComponent<Tile> ();
//				if (tile.GetTier () > 0) {
//					upgradableTiles.Add (tileobject);
//				} else {
//					emptyTiles.Add (tileobject);
//				}
//			}

//			foreach (GameObject tileobject in upgradableTiles){
//				Tile tile = tileobject.GetComponent<Tile> ();
//				int pressure = 0;
//				foreach (GameObject neighbourTile in tile.neighbourTiles) {
//					pressure += neighbourTile.GetComponent<Tile> ().GetTier ();
//				}
//
//				pressure += tile.GetZoning ();
//
//				if (pressure > 7 && tile.GetTier () < 3 && freePopulation >= 3 - tile.GetTier()) {
//					freePopulation -= 3 - tile.GetTier();
//					tile.SetTier (3);
//				} else if (pressure > 3 && tile.GetTier () < 2 && freePopulation >= 2 - tile.GetTier()) {
//					freePopulation -= 2 - tile.GetTier();
//					tile.SetTier (2);
//				} else if (pressure > 2 && tile.GetTier () < 1 && freePopulation >= 0) {
//					freePopulation -= 1 - tile.GetTier();
//					tile.SetTier (1);
//				}
//
//
//				if (freePopulation <= 1 && pressure > 4) {
//					abandon = true;
//				}
//				if (abandon == true && pressure <= 3 && tile.GetTier() > 0) {
//					tile.SetTier (tile.GetTier() - 1);
//					freePopulation += 1;
//					abandon = false;
//				}
//				tile.DecreaseZoning ();
//			}
//
//			foreach (GameObject tileobject in emptyTiles) {
//				Tile tile = tileobject.GetComponent<Tile> ();
//				int pressure = 0;
//				foreach (GameObject neighbourTile in tile.neighbourTiles) {
//					pressure += neighbourTile.GetComponent<Tile> ().GetTier ();
//				}
//
//				pressure += tile.GetZoning ();
//
//				if (pressure > 1 && tile.GetTier () < 1 && freePopulation >= 0) {
//					freePopulation -= 1 - tile.GetTier();
//					tile.SetTier (1);
//				}
//				tile.DecreaseZoning ();
//
//			}
//			upgradableTiles.Clear ();
//			emptyTiles.Clear ();
				waveCooldown = true;
				clicks++;
				freePopulation++;
				if (clicks > maxClicks) {
					clicks = maxClicks;
				}
			}
		}

//		if (waveCooldown == false) {
//			foreach (GameObject tile in TileArray) {
//				int upgradePressure = 0;
//				foreach (GameObject neighbourTile in tile.GetComponent<Tile>().neighbourTiles) {
//					Sprite neighbour = neighbourTile.GetComponent<SpriteRenderer> ().sprite;
//					Sprite thisTile = tile.GetComponent<SpriteRenderer> ().sprite;
//					if (thisTile == building1) {
//						if (neighbour == building3) {
//							upgradePressure++;
//							upgradePressure++;
//						} else if (neighbour == building2) {
//							upgradePressure++;
//						}
//					} else if (thisTile == building2) {
//						if (neighbour == building3) {
//							upgradePressure++;
//							upgradePressure++;
//						} else if (neighbour == building1 || neighbour == building2) {
//							upgradePressure++;
//						} else if (neighbour == grass) {
//							upgradePressure--;
//						}
//					} else if (thisTile == building3) {
//						if (neighbour == grass) {
//							upgradePressure--;
//							upgradePressure--;
//						}
//					}
//
//					if (upgradePressure >= 3) {
//						if (thisTile == building1) {
//							tile.GetComponent<SpriteRenderer> ().sprite = building2;
//						} else if (thisTile == building2) {
//							tile.GetComponent<SpriteRenderer> ().sprite = building3;
//						}
//					} else if (upgradePressure < 0) {
//						if (thisTile == building3) {
//							tile.GetComponent<SpriteRenderer> ().sprite = building2;
//						}
//					}
//				}
//			}
//			waveCooldown = true;
//			Debug.Log ("Wave");
//			clicks++;
//			if (clicks > 5) {
//				clicks = 5;
//			}
//		}
	}

	public void AddTileToArray(GameObject tile, int place){
		//TileArray [place] = tile;
	}
}
